# PA165 Movie Recommender Catalogue

*PA165 course at MUNI Spring 2023.*

# Project description

The web application is a catalogue of movies of different genres. 
Each movie has a title, description, film director, and list of actors, and image(s) from the main playbill. 
Each movie is categorized in one or more genres. 
Only the administrator can create, remove and update the list of movies. 

Users can register and log in to get access to the application. 
The administrator account is created by the system.

Users can rate the movies according to different criteria 
(e.g how novel are the ideas of the movie, their final score, etc…). 

The main feature of the system is that users can pick one movie 
and get the list of similar movies and / or movies that were liked the most by other users watching the same movie.

## Services description

Each service is designated to do operations that are common i some way.

### RecommenderService
This service generates a list of movies that are similar with the given movie.

### MovieService
This service stores all the data. Other services calls it to get the data.

### LoginService
This service handles authentication. 
It decides whether the provided login is valid and returns authentication token.

## Docker
In order to run Movie Recommender Catalogue in docker, first run in the main project folder:

    mvn clean install

Then start the application with docker:

    docker-compose up

## Diagrams
![use-case-diagram.png](src/diagrams/images/use-case-diagram.png)
![class-diagram.png](src/diagrams/images/class-diagram.png)

# Interaction with backend:
DB: http://localhost:8080/h2-console

and log in with credentials from
src/main/resources/application.yml

Swagger: http://localhost:8080/swagger-ui/index.html
